
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Room_typesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const room_types = await db.room_types.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        code: data.code
        ||
        null
            ,
            
        short_description: data.short_description
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        max_occupancy: data.max_occupancy
        ||
        null
            ,
            
        max_adults: data.max_adults
        ||
        null
            ,
            
        max_children: data.max_children
        ||
        null
            ,
            
        bed_count: data.bed_count
        ||
        null
            ,
            
        bed_type: data.bed_type
        ||
        null
            ,
            
        base_area_sqm: data.base_area_sqm
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await room_types.setHotel( data.hotel || null, {
            transaction,
        });
        

        
        await room_types.setAmenities(data.amenities || [], {
            transaction,
        });
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.room_types.getTableName(),
                belongsToColumn: 'images',
                belongsToId: room_types.id,
            },
            data.images,
            options,
        );
        

        return room_types;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const room_typesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                code: item.code
            ||
            null
            ,
            
                short_description: item.short_description
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                max_occupancy: item.max_occupancy
            ||
            null
            ,
            
                max_adults: item.max_adults
            ||
            null
            ,
            
                max_children: item.max_children
            ||
            null
            ,
            
                bed_count: item.bed_count
            ||
            null
            ,
            
                bed_type: item.bed_type
            ||
            null
            ,
            
                base_area_sqm: item.base_area_sqm
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const room_types = await db.room_types.bulkCreate(room_typesData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < room_types.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.room_types.getTableName(),
                    belongsToColumn: 'images',
                    belongsToId: room_types[i].id,
                },
                data[i].images,
                options,
            );
        }
        

        return room_types;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const room_types = await db.room_types.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.code !== undefined) updatePayload.code = data.code;
        
        
        if (data.short_description !== undefined) updatePayload.short_description = data.short_description;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.max_occupancy !== undefined) updatePayload.max_occupancy = data.max_occupancy;
        
        
        if (data.max_adults !== undefined) updatePayload.max_adults = data.max_adults;
        
        
        if (data.max_children !== undefined) updatePayload.max_children = data.max_children;
        
        
        if (data.bed_count !== undefined) updatePayload.bed_count = data.bed_count;
        
        
        if (data.bed_type !== undefined) updatePayload.bed_type = data.bed_type;
        
        
        if (data.base_area_sqm !== undefined) updatePayload.base_area_sqm = data.base_area_sqm;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        updatePayload.updatedById = currentUser.id;

        await room_types.update(updatePayload, {transaction});

        
        
        if (data.hotel !== undefined) {
            await room_types.setHotel(
              
              data.hotel,
              
              { transaction }
            );
        }
        

        
        
        if (data.amenities !== undefined) {
            await room_types.setAmenities(data.amenities, { transaction });
        }
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.room_types.getTableName(),
                belongsToColumn: 'images',
                belongsToId: room_types.id,
            },
            data.images,
            options,
        );
        

        return room_types;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const room_types = await db.room_types.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of room_types) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of room_types) {
                await record.destroy({transaction});
            }
        });


        return room_types;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const room_types = await db.room_types.findByPk(id, options);

        await room_types.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await room_types.destroy({
            transaction
        });

        return room_types;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const room_types = await db.room_types.findOne(
            { where },
            { transaction },
        );

        if (!room_types) {
            return room_types;
        }

        const output = room_types.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        output.rooms_room_type = await room_types.getRooms_room_type({
            transaction
        });
        
        
        
        
        
        output.seasonal_rates_room_type = await room_types.getSeasonal_rates_room_type({
            transaction
        });
        
        
        output.inventory_blocks_room_type = await room_types.getInventory_blocks_room_type({
            transaction
        });
        
        
        
        output.bookings_room_type = await room_types.getBookings_room_type({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.hotel = await room_types.getHotel({
            transaction
        });
        
        
        output.images = await room_types.getImages({
            transaction
        });
        
        
        output.amenities = await room_types.getAmenities({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.hotels,
        as: 'hotel',
        
        where: filter.hotel ? {
          [Op.or]: [
            { id: { [Op.in]: filter.hotel.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.hotel.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },


      {
        model: db.amenities,
        as: 'amenities',
        required: false,
      },


      {
        model: db.file,
        as: 'images',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'room_types',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'room_types',
                        'code',
                        filter.code,
                    ),
                };
            }
            
            if (filter.short_description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'room_types',
                        'short_description',
                        filter.short_description,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'room_types',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            
            if (filter.max_occupancyRange) {
                const [start, end] = filter.max_occupancyRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    max_occupancy: {
                    ...where.max_occupancy,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    max_occupancy: {
                    ...where.max_occupancy,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.max_adultsRange) {
                const [start, end] = filter.max_adultsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    max_adults: {
                    ...where.max_adults,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    max_adults: {
                    ...where.max_adults,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.max_childrenRange) {
                const [start, end] = filter.max_childrenRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    max_children: {
                    ...where.max_children,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    max_children: {
                    ...where.max_children,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.bed_countRange) {
                const [start, end] = filter.bed_countRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    bed_count: {
                    ...where.bed_count,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    bed_count: {
                    ...where.bed_count,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.base_area_sqmRange) {
                const [start, end] = filter.base_area_sqmRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    base_area_sqm: {
                    ...where.base_area_sqm,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    base_area_sqm: {
                    ...where.base_area_sqm,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.bed_type) {
                where = {
                    ...where,
                bed_type: filter.bed_type,
            };
            }
            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      


      if (filter.amenities) {
        const searchTerms = filter.amenities.split('|');

        include = [
          {
            model: db.amenities,
            as: 'amenities_filter',
            required: searchTerms.length > 0,
            where: searchTerms.length > 0 ? {
              [Op.or]: [
                { id: { [Op.in]: searchTerms.map(term => Utils.uuid(term)) } },
                { 
                  name: {
                    [Op.or]: searchTerms.map(term => ({ [Op.iLike]: `%${term}%` }))
                  }
                }
              ]
            } : undefined
          },
          ...include,
        ]
      }


            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.room_types.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'room_types',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.room_types.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

